        .386p
        jumps
include	code32.inc

extrn   _totalextmem:word, _code16a:dword, _code32a:dword, _hextbl:byte
extrn   _lomembase:dword, _lomemtop:dword, _himembase:dword, _himemtop:dword

extrn   _putdosmsg:near, _getvect:near, _setvect:near, _exit:near
extrn   _getmem:near, _getlomem:near, _gethimem:near, _lomemsize:near
extrn   _himemsize:near, _ret:near

; Move realatively adjusted pointer to reg
@rlp    macro reg, ptr
        mov &reg,&ptr
        sub &reg,_code32a
endm

; Output a byte to DX
@outb           macro   val
        mov al,&val
        out dx,al
endm

; Output a word to DX
@outw           macro   val
        mov ax,&val
        out dx,ax
endm


extrn	halloc:near, hmax:near
extrn	getkey:near

public  _main

;
; DATA
;
msg0	db 'Free low mem:  '
msg0len=$-msg0
msg1	db 'Free high mem: '
msg1len=$-msg1
msg2	db 'Free heap mem: '
msg2len=$-msg2

;
; CODE
;

;
_main:
        @rlp edi,0b8000h                ; fill text screen with stuff
        mov ecx,80*25
        mov al,''
        mov ah,78h
        rep stosw

        mov ah,0fh                      ; put amount of free low mem
        @rlp edi,0b8000h+2*160+4
        mov esi,offset msg0
        mov ecx,msg0len
mainl0:
        lodsb
        stosw
        loop mainl0
        call _lomemsize
        call putnum

        @rlp edi,0b8000h+3*160+4        ; put amount of free high mem
        mov esi,offset msg1
        mov ecx,msg1len
mainl1:
        lodsb
        stosw
        loop mainl1
        call _himemsize
        call putnum

	mov	eax,1000h-4
	call	halloc
        mov ah,0fh

        @rlp edi,0b8000h+4*160+4        ; put amount of free heap mem
        mov esi,offset msg2
        mov ecx,msg2len
mainl2:
        lodsb
        stosw
        loop mainl2
        call	hmax
        call putnum

; Uncomment this and the next piece of code if you have a mouse driver loaded
; and want to test the handling of real-mode IRQs.
	mov v86r_ax,0                   ; Enable and unhide mouse cursor
	mov al,33h
	int 30h
	mov v86r_ax,1
	int 30h

	call	getkey
;        mov v86r_ah,0                   ; INT 16h, AH=0, wait for keypress
 ;       mov al,16h
  ;      int 30h

	mov v86r_ax,0                   ; Disable mouse
	mov al,33h
	int 30h

        jmp _exit                       ; return to real mode

;-----------------------------------------------------------------------------
putnum:                                 ; put EAX to EDI
        mov edx,eax
        mov ecx,8
        mov ebx,offset _hextbl
        mov ah,0fh
putnuml0:
        rol edx,4
        mov al,dl
        and al,0fh
        xlat
        stosw
        loop putnuml0
        ret


code32  ends
        end

